# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::NewsSearch::V1_0
  module Models
    #
    # Defines a news article.
    #
    class NewsArticle < Article

      include MsRestAzure


      def initialize
        @_type = "NewsArticle"
      end

      attr_accessor :_type

      # @return [String] The news category that the article belongs to. For
      # example, Sports. If the news category cannot be determined, the article
      # does not include this field.
      attr_accessor :category

      # @return [Boolean] A Boolean value that indicates whether the news
      # article is a headline. If true, the article is a headline. The article
      # includes this field only for news categories requests that do not
      # specify the category query parameter.
      attr_accessor :headline

      # @return [Array<NewsArticle>] A list of related news articles.
      attr_accessor :clustered_articles


      #
      # Mapper for NewsArticle class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'NewsArticle',
          type: {
            name: 'Composite',
            class_name: 'NewsArticle',
            model_properties: {
              _type: {
                client_side_validation: true,
                required: true,
                serialized_name: '_type',
                type: {
                  name: 'String'
                }
              },
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              web_search_url: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'webSearchUrl',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              url: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'url',
                type: {
                  name: 'String'
                }
              },
              image: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'image',
                type: {
                  name: 'Composite',
                  class_name: 'ImageObject'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              },
              alternate_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'alternateName',
                type: {
                  name: 'String'
                }
              },
              bing_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'bingId',
                type: {
                  name: 'String'
                }
              },
              thumbnail_url: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'thumbnailUrl',
                type: {
                  name: 'String'
                }
              },
              provider: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'provider',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ThingElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Thing'
                      }
                  }
                }
              },
              date_published: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'datePublished',
                type: {
                  name: 'String'
                }
              },
              video: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'video',
                type: {
                  name: 'Composite',
                  class_name: 'VideoObject'
                }
              },
              word_count: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'wordCount',
                type: {
                  name: 'Number'
                }
              },
              category: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'category',
                type: {
                  name: 'String'
                }
              },
              headline: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'headline',
                type: {
                  name: 'Boolean'
                }
              },
              clustered_articles: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'clusteredArticles',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'NewsArticleElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'NewsArticle'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
