# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::NewsSearch::V1_0
  module Models
    #
    # Model object.
    #
    #
    class NewsTopic < Thing

      include MsRestAzure


      def initialize
        @_type = "News/Topic"
      end

      attr_accessor :_type

      # @return [Boolean] A Boolean value that indicates whether the topic is
      # considered breaking news. If the topic is considered breaking news, the
      # value is true.
      attr_accessor :is_breaking_news

      # @return [Query] A search query term that returns this trending topic.
      attr_accessor :query

      # @return [String] The URL to the Bing News search results for the search
      # query term
      attr_accessor :news_search_url


      #
      # Mapper for NewsTopic class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'News/Topic',
          type: {
            name: 'Composite',
            class_name: 'NewsTopic',
            model_properties: {
              _type: {
                client_side_validation: true,
                required: true,
                serialized_name: '_type',
                type: {
                  name: 'String'
                }
              },
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              web_search_url: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'webSearchUrl',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              url: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'url',
                type: {
                  name: 'String'
                }
              },
              image: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'image',
                type: {
                  name: 'Composite',
                  class_name: 'ImageObject'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              },
              alternate_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'alternateName',
                type: {
                  name: 'String'
                }
              },
              bing_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'bingId',
                type: {
                  name: 'String'
                }
              },
              is_breaking_news: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'isBreakingNews',
                type: {
                  name: 'Boolean'
                }
              },
              query: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'query',
                type: {
                  name: 'Composite',
                  class_name: 'Query'
                }
              },
              news_search_url: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'newsSearchUrl',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
